<?php

namespace Makeitneutral\MNL\Block\Cart;

use \Magento\Checkout\Model\ConfigProviderInterface;

class AdditionalConfigVars extends Makeitneutral implements ConfigProviderInterface
{
    public function getConfig()
    {
        if (is_null($this->getProductId())) {
            return [];
        }
        $helper = $this->getHelper();
        $product = $this->getProduct();
        $priceHelper = $this->getPriceHelper();
        $cartitem = $this->getNeutralProductFromCart($product);
        $co2weight = 0;
        $iconcolor = '#558b2f';
		$filename = "makeitneutral.png";
        $showdecimal = true;
        if ($product->getPrice() == intval($product->getPrice())) {
            $showdecimal = false;
        }
		$mnl_title = $helper->getConfig("mnl/general/title");
		$mnl_text = $helper->getConfig("mnl/general/text");
		
        $price = $priceHelper->currency($product->getPrice(), true, false);

        $additionalVariables['makeitneutral_data'] = [
            'icon_colour' => $iconcolor,
			'mnl_title' => $mnl_title,
            'makeitneutral_logo' => $this->getProductImage(),
            'mnl_text' => $mnl_text,
			'neutralweight' => $co2weight,
            'addtocarturl' => $this->getAddtocartUrl($product),
            'product_price' => $showdecimal ? $price : substr($price, 0, strpos($price, ".")),
            'product_in_cart' => $cartitem ? true : false,
            'remove_url' => $cartitem ? $this->getRemoveCartUrl($cartitem) : false,
            'item_id' => $cartitem ? $cartitem->getId() : false,
            'removeitem_url' => $this->getRemoveItemUrl()
        ];
        return $additionalVariables;
    }

    public function getRemoveItemUrl()
    {
        return $this->getUrl('checkout/sidebar/removeItem', ['_secure' => $this->getRequest()->isSecure()]);
    }
}
