<?php

namespace Makeitneutral\MNL\Block\Cart;

use Magento\Catalog\Api\ProductRepositoryInterface;

class Makeitneutral extends \Magento\Framework\View\Element\Template
{
    protected $helper;
    protected $productRepository;
    protected $priceHelper;
    protected $cartHelper;
	
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Makeitneutral\MNL\Helper\Minhelp $helper,
        ProductRepositoryInterface $productRepository,
        \Magento\Framework\Pricing\Helper\Data $priceHelper,
        \Magento\Checkout\Helper\Cart $cartHelper,
        array $data = []
    ) {
        $this->helper = $helper;
        $this->productRepository = $productRepository;
        $this->priceHelper = $priceHelper;
        $this->cartHelper = $cartHelper;
        parent::__construct($context, $data);
    }

    public function getHelper()
    {
        return $this->helper;
    }

    public function getProduct()
    {
        return $product = $this->productRepository->getById($this->getProductId());
    }

    public function getProductId()
    {
        return $this->getHelper()->getConfig("mnl/general/product");
    }

	public function getProductImage(){
		$product_id = $this->getProductId();
		$product_image_url = "";
		
		$product = $this->productRepository->getById($product_id);
		$product_image_url = $this->_storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA) . 'catalog/product' . $product->getImage();
		
		return $product_image_url;
	}
	
    public function getPriceHelper()
    {
        return $this->priceHelper;
    }

    public function getAddtocartUrl($product)
    {
        return $this->cartHelper->getAddUrl($product, []);
    }

    public function getNeutralProductFromCart($product)
    {
        return $this->cartHelper->getQuote()->getItemByProduct($product);
    }

    public function getRemoveCartUrl($item)
    {
        return $this->cartHelper->getDeletePostJson($item);
    }
}
