<?php
namespace Makeitneutral\MNL\Block\System\Config;

class Checkbox extends \Magento\Config\Block\System\Config\Form\Field
{

    const CONFIG_PATH = 'mnl/general/widget_location';
 
    protected $_template = 'Makeitneutral_MNL::system/config/checkbox.phtml';
 
    protected $_values = null;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        array $data = []
    ) {
        parent::__construct($context, $data);
    }
    
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element)
    {
        $this->_values = $element->getValue();

        $this->setNamePrefix($element->getName())
            ->setHtmlId($element->getHtmlId());
 
        return $this->_toHtml();
    }
    
    public function getValues()
    {
        $values = [];
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
 
        foreach ($objectManager->create('Makeitneutral\MNL\Model\Config\Checkbox')->toOptionArray() as $value) {
            $values[$value['value']] = $value;
        }
 
        return $values;
    }
   
    public function getIsChecked($name)
    {
        return in_array($name, $this->getCheckedValues());
    }
    
    public function getCheckedValues()
    {

        if (is_null($this->_values)) {
            $data = $this->getConfigData();
            if (isset($data[self::CONFIG_PATH])) {
                $data = $data[self::CONFIG_PATH];
            } else {
                $data = '';
            }
            $this->_values = explode(',', $data);
        }

        if ($this->_values && !is_array($this->_values)) {
            $this->_values = explode(",", $this->_values);
        }
 
        return $this->_values;
    }
}
