<?php
namespace Makeitneutral\MNL\Model\Config\Backend;

class Enable extends \Magento\Framework\App\Config\Value
{

    protected $mnlproduct;
	protected $saveconfig;
	protected $jsonHelper;
	
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\App\Config\ScopeConfigInterface $config,
        \Magento\Framework\App\Cache\TypeListInterface $cacheTypeList,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        \Makeitneutral\MNL\Model\CreateProduct $mnlproduct,
		\Makeitneutral\MNL\Model\Service\SaveDashboard $saveconfig,
		\Magento\Framework\Json\Helper\Data $jsonHelper,
        array $data = []
    ) {
       
        $this->mnlproduct = $mnlproduct;
		$this->saveconfig = $saveconfig;
		$this->jsonHelper = $jsonHelper;
        parent::__construct(
            $context,
            $registry,
            $config,
            $cacheTypeList,
            $resource,
            $resourceCollection,
            $data
        );
    }

    public function afterSave()
    {
		
        $storedata = array();
		$storedata['success'] = true;
		$storedata['mode'] = "postpaid";
		$this->saveconfig->saveConfig('mnl/general/shop', $this->jsonHelper->jsonEncode($storedata));
		$this->saveconfig->saveConfig('mnl/general/postpaid', 1);
        if ($this->isValueChanged()) {
             $this->mnlproduct->UpdateStatus($this->getValue());
             $value = $this->getValue() == 1? true: false;
        }
        return parent::afterSave();
    }

    public function beforeSave()
    {
		if($this->getValue() == 1){
			 $this->mnlproduct->CreateProduct();
		}

        return parent::beforeSave();
    }
}
