<?php
namespace Makeitneutral\MNL\Model\Service;

abstract class AbstractService
{
	const MAKEITNEUTRAL_CONFIG_URL = 'https://makeitneutral.com/wp-json/makeitneutral/v1/';
	const MAKEITNEUTRAL_CONFIG_URL_TEST = 'https://dev.makeitneutral.com/wp-json/makeitneutral/v1/';

    protected $scopeConfig;
    protected $storeManager;
    protected $messageManager;
    protected $authSession;
    protected $configWriter;
    protected $curl;
    protected $curlFactory;
    protected $orderCollectionFactory;
    protected $jsonHelper;
    protected $logger;
    protected $authdata = [];
    protected $apiConfig = [];
    
    public function __construct(
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Framework\App\Config\Storage\WriterInterface $configWriter,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Backend\Model\Auth\SessionFactory $authSession,
        Curl $curl,
        \Magento\Sales\Model\ResourceModel\Order\CollectionFactory $orderCollectionFactory,
        \Magento\Framework\HTTP\Adapter\CurlFactory $curlFactory,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Psr\Log\LoggerInterface $logger
    ) {
        
        $this->scopeConfig = $scopeConfig;
        $this->storeManager = $storeManager;
        $this->configWriter = $configWriter;
        $this->authSession = $authSession;
        $this->messageManager = $messageManager;
        $this->curl = $curl;
        $this->orderCollectionFactory = $orderCollectionFactory;
        $this->curlFactory = $curlFactory;
        $this->jsonHelper = $jsonHelper;
        $this->logger = $logger;
    }

    public function getConfig($path)
    {
        return $this->scopeConfig->getValue($path);
    }

    protected function refreshCache()
    {
        
        $this->scopeConfig->clean();
    }
}
