<?php

namespace Makeitneutral\MNL\Observer;

use Makeitneutral\MNL\Helper\Minhelp;
use Magento\Framework\Event\ObserverInterface;

class CancelOrderObserver implements ObserverInterface
{
    protected $helper;
    protected $_logger;

    public function __construct(
        Minhelp $helper,
        \Psr\Log\LoggerInterface $logger
    ) {
        $this->helper = $helper;
        $this->_logger = $logger;
    }

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $order = $observer->getEvent()->getOrder();
        if (empty($this->helper->getConfig('mnl/general/shop'))) {
            return $this;
        }
        $productId = $this->helper->getConfig('mnl/general/product');
        foreach ($order->getAllVisibleItems() as $item) {
            if ($item->getProductId() == $productId) {
                $params = [
                    "number"=> $order->getEntityId(),
                    "cancel_reason"=> "Order Cancelled",
                ];
                $this->_logger->log(100, print_r($params, true));
                break;
            }
        };
        return $this;
    }
}
