<?php
namespace Makeitneutral\MNL\Observer;

use Makeitneutral\MNL\Helper\Minhelp;
use Magento\Framework\Event\ObserverInterface;
use Magento\Directory\Model\CountryFactory;
use Magento\Framework\UrlInterface;
use Magento\Sales\Model\ResourceModel\Order;
use Makeitneutral\MNL\Model\Service\Mnl\ApiData;

class OrderObserver implements ObserverInterface
{
    protected $helper;
    protected $countryfactory;
    protected $OrderResource;
    protected $urlinterface;
    protected $_logger;
	protected $apidata;

    public function __construct(
        Order $OrderResource,
        Minhelp $helper,
        CountryFactory $countryfactory,
        UrlInterface $UrlInterface,
		ApiData $apidata,
        \Psr\Log\LoggerInterface $logger
    ) {
        $this->helper = $helper;
        $this->countryfactory = $countryfactory;
        $this->OrderResource = $OrderResource;
        $this->urlinterface = $UrlInterface;
		$this->apidata = $apidata;
        $this->_logger = $logger;
    }

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $order = $observer->getEvent()->getOrder();
        if (!$order->getId()) {
            return $this;
        }
		
        if (!is_null($order->getMakeitneutralSyncFailed()) && ($order->getMakeitneutralSyncFailed() == 0 || $order->getMakeitneutralSyncFailed() == 1)) {
            return $this;
        }
        $productId = $this->helper->getConfig('mnl/general/product');
        $showcart = [];
        foreach ($order->getAllVisibleItems() as $item) {
            if ($item->getProductId() == $productId) {;
                $billingaddress = $order->getBillingAddress();
                
				$order_id = $order->getEntityId();
				$params = array(
					"name" => trim($billingaddress->getFirstname()).' '.trim($billingaddress->getLastname()),
					"email" => trim($order->getCustomerEmail()),
					"amountoftrees" => (int)$item->getQtyOrdered()
				);
				
                $this->_logger->log(100,print_r($params,true));
			    $sendOrder = $this->apidata->sendOrderToApi($order_id, $params);
                if ($sendOrder) {
                    $order->setMakeitneutralSyncFailed(0);
                } else {
                    $order->setMakeitneutralSyncFailed(1);
                }
                $this->OrderResource->saveAttribute($order, 'makeitneutral_sync_failed');
                $showcart['last_impression'] = true;
                break;
            }
        }
		
        $this->_logger->log(100, print_r($params, true));
        return $this;
    }
}
