<?php
namespace Makeitneutral\MNL\Plugin\SalesRule\Model;

use Magento\Framework\Session\SessionManager;
 
class RulesApplier
{
    private $ruleCollection;

    private $helper;
 
    public function __construct(
        \Magento\SalesRule\Model\ResourceModel\Rule\CollectionFactory $rulesFactory,
        \Makeitneutral\MNL\Helper\Minhelp $helper
    ) {
        $this->ruleCollection = $rulesFactory;
        $this->helper = $helper;
    }
 
    public function aroundApplyRules(
        \Magento\SalesRule\Model\RulesApplier $subject,
        \Closure $proceed,
        $item,
        $rules,
        $skipValidation,
        $couponCode
    ) {
        if ($this->helper->getConfig('mnl/general/enable') == 1 && $this->helper->getConfig('mnl/general/product')) {
            if ($item->getProductId() == $this->helper->getConfig('mnl/general/product')) {
                $rules = $this->ruleCollection->create()->addFieldToSelect('*')->addFieldToFilter("coupon_type", ["eq"=>1])->addFieldToFilter("is_active", ["eq"=>1]);
            }
        }
        $result = $proceed($item, $rules, $skipValidation, $couponCode);
        return $result;
    }
}
