/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
define([
    'jquery',
    'ko',
    'uiComponent',
    'Makeitneutral_MNL/js/action/addtocart',
    'Makeitneutral_MNL/js/action/removefromcart'
], function ($,ko, Component,addtocart,removefromcart) {
    'use strict';

    var makeitneutraldata = window.checkoutConfig.makeitneutral_data;

    var productincart = ko.observable(null);
    var makeitneutral = ko.observable(null);

    $(document).on('click','#mnl-learn-more', function(e){
        e.preventDefault();
        $('#'+$(this).attr('data-action')).toggle();
    });

    makeitneutral(makeitneutraldata);

    productincart(makeitneutraldata.product_in_cart);

    return Component.extend({
        defaults: {
            template: 'Makeitneutral_MNL/payment/makeitneutral'
        },

        productincart:productincart,
        makeitneutral:makeitneutral,


        getparameter: function(parameter){
            var data = makeitneutral();
            if(data){
                return makeitneutraldata[parameter];
            }
            return;
        },

        getWeightUnit: function(){
            var weightdata = this.getparameter('neutralweight');
            if(weightdata){
                return '('+weightdata[1]+')';
            }
            return;
        },

        getWeight: function(){
            var weightdata = this.getparameter('neutralweight');
            if(weightdata){
                return weightdata[0];
            }
            return;
        },

        getFormkey: function(){
            return $.mage.cookies.get('form_key');
        },

        MnlAddtocart: function(){
            addtocart(makeitneutraldata.addtocarturl, $("#add-to-cart-mnl"), productincart,makeitneutral);
        },

        mnlremovecart: function(){
            removefromcart(makeitneutral().removeitem_url,JSON.parse(makeitneutral().remove_url),productincart,makeitneutral)
        }

    });
});
